#ifndef _KILIB_KTL_ARRAY_H_
#define _KILIB_KTL_ARRAY_H_
#include "types.h"
#include "memory.h"
#ifndef __ccdoc__
namespace ki {
#endif



//=========================================================================
//@{ @pkg ki.KTL //@}
//@{
//	{^p̉ϒz
//
//	ɊȑfȍłBANZX͍DȂƂ֎Rɉ\łA
//	vf̒ǉE폜͖ɑ΂Ă̂݁Brbg̃Rs[ƂA
//	FXGLZgbNȍƂĂ܂̂ŁAƂėǂ
//	^ȊOɂ͎gȂłB
//@}
//=========================================================================

template <typename T>
class storage : public Object
{
public:

	//@{
	//	RXgN^
	//
	//	@param alloc_size
	//		ŏɊmۂ""TCYB
	//		"z"TCYł͂ȂƂɒӁB
	//@}
	explicit storage( ulong allocSize=20 )
		: alen_( Max( allocSize, 1UL ) )
		, len_ ( 0 )
		, buf_ ( static_cast<T*>(mem().Alloc(alen_*sizeof(T))) )
		{}

	~storage()
		{ mem().DeAlloc( buf_, alen_*sizeof(T) ); }

	//@{ ɗvfǉ //@}
	void Add( const T& obj )
		{
			if( len_ >= alen_ )
				ReAllocate( alen_<<2 );
			buf_[ len_++ ] = obj;
		}

	//@{
	//	zTCYύX
	//
	//	k/ĝǂ\BRXgN^ƈႢA
	//	w肵lɊÂőindexω܂B
	//	@param new_size VTCYB
	//@}
	void ForceSize( ulong newSize )
		{
			if( newSize > alen_ )
				ReAllocate( newSize );
			len_ = newSize;
		}

public:

	//@{ vf	//@}
	ulong size() const
		{ return len_; }

	//@{ vf擾 //@}
	T& operator[]( ulong i )
		{ return buf_[i]; }

	//@{ vf擾(const) //@}
	const T& operator[]( ulong i ) const
		{ return buf_[i]; }

	//@{ z擪̃|C^Ԃ //@}
	const T* head() const
		{ return buf_; }

private:

	void ReAllocate( ulong siz )
		{
			ulong p = alen_*sizeof(T);
			T* newbuf = static_cast<T*>
				(mem().Alloc( (alen_=siz)*sizeof(T) ));
			memcpy( newbuf, buf_, len_*sizeof(T) );
			mem().DeAlloc( buf_, p );
			buf_ = newbuf;
		}

private:

	ulong alen_;
	ulong len_;
	T*    buf_;

private:

	NOCOPY(storage<T>);
};



//=========================================================================

}      // namespace ki
#endif // _KILIB_KTL_ARRAY_H_
